--- old/usr/src/uts/common/fs/proc/prdata.h	Wed Apr 12 20:33:30 2023
+++ new/usr/src/uts/common/fs/proc/prdata.h	Wed Apr 12 20:33:30 2023
@@ -29,6 +29,7 @@
 /*
  * Copyright 2019 Joyent, Inc.
  * Copyright 2020 OmniOS Community Edition (OmniOSce) Association.
+ * Copyright 2023 Oxide Computer Company
  */
 
 #ifndef _SYS_PROC_PRDATA_H
@@ -409,11 +410,7 @@
 extern	int	prgetrvals(klwp_t *, long *, long *);
 extern	void	prgetprfpregs(klwp_t *, prfpregset_t *);
 extern	void	prsetprfpregs(klwp_t *, prfpregset_t *);
-extern	void	prgetprxregs(klwp_t *, caddr_t);
-extern	void	prsetprxregs(klwp_t *, caddr_t);
-extern	int	prgetprxregsize(proc_t *);
 extern	int	prhasfp(void);
-extern	int	prhasx(proc_t *);
 extern	caddr_t	prgetstackbase(proc_t *);
 extern	caddr_t	prgetpsaddr(proc_t *);
 extern	int	prisstep(klwp_t *);
@@ -421,6 +418,76 @@
 extern	int	prfetchinstr(klwp_t *, ulong_t *);
 extern	ushort_t prgetpctcpu(uint64_t);
 
+/*
+ * This set of routines is used by platforms to implement support for the
+ * 'xregs' or extended registers in /proc. Unlike other registers which
+ * generally have a well-defined value determined by the ABI that never changes,
+ * we expect these to change.
+ *
+ * An important thing to note is that you'll see we have moved away from a
+ * traditional version of a fixed size, non-opaque definition of the
+ * prxregset_t. This is because the size varies and we don't want applications
+ * to incorrectly bake a real definition in and cause problems where extending
+ * it becomes very hard to do (ala the prgregset_t and prfregset_t). This is a
+ * little more work for everyone implementing it, but it does ensure that we are
+ * generally in better shape.
+ *
+ * Here are the semantics of what these are required * to do and how the fit
+ * together:
+ *
+ *   o prhasx		Determine if the process in question supports the
+ *			extended register sets. Note, this is may be a
+ *			process-specific setting due to things like whether or
+ *			not the FPU is enabled or other things.
+ *
+ *   o prgetxregsize	This returns the size of the actual xregs file for a
+ *			given process. This may change between processes because
+ *			not every process may have the same set of extended
+ *			features enabled (e.g. AMX on x86).
+ *
+ *   o prwriteminxreg	This is used by the prwritectl() and related worlds to
+ *			determine the minimum amount of data that much be
+ *			present to determine if the actual size of a write is
+ *			valid. If xregs is not supported, then this should
+ *			return B_FALSE.
+ *
+ *   o prwritesizexreg	This is meant to indicate how much data is required to
+ *			be copied in for a given xregs write. The base data will
+ *			already be present from having called prwriteminxreg
+ *			previously. If xregs are not supported this should
+ *			return B_FALSE.
+ *
+ *			There is a wrinkle in this which is not true of other
+ *			callers. The data that we are given is not guaranteed to
+ *			be aligned in the slightest due to the need to support
+ *			both ILP32 and LP64!
+ *
+ *   o prgetprxregs	This is a request to fill in the xregs data. Right now
+ *			the system guarantees that the buffer size is at least
+ *			the result of the prgetprxregs() call for this process.
+ *			Callers may assume that the process remains locked
+ *			between the two so that the size doesn't change.
+ *
+ *   o prsetprxregs	This is a request to set the xregs data. The only
+ *			assumption that should be made is that the validation of
+ *			the size has been done in prvalidpcsxreg() as been
+ *			performed. Users can and will potentially try to trick
+ *			us with invalid values. Do not blindly apply this unless
+ *			there is something that is impossible about that, but
+ *			given that our recommendations for this are variable
+ *			width data, that should not happen.
+ *
+ *			If xregs are not supported this should return EINVAL.
+ *			While yes other errnos may make more sense, that is what
+ *			we have always returned in /proc for this case.
+ */
+extern	int	prhasx(proc_t *);
+extern	size_t	prgetprxregsize(proc_t *);
+extern	void	prgetprxregs(klwp_t *, prxregset_t *);
+extern	boolean_t prwriteminxreg(size_t *);
+extern	boolean_t prwritesizexreg(const void *, size_t *);
+extern	int	prsetprxregs(klwp_t *, prxregset_t *);
+
 #endif	/* _KERNEL */
 
 #ifdef	__cplusplus
--- old/usr/src/uts/common/fs/proc/prioctl.c	Wed Apr 12 20:33:30 2023
+++ new/usr/src/uts/common/fs/proc/prioctl.c	Wed Apr 12 20:33:30 2023
@@ -23,6 +23,7 @@
  * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  * Copyright 2019 Joyent, Inc.
+ * Copyright 2023 Oxide Computer Company
  */
 
 /*	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T	*/
@@ -209,12 +210,24 @@
 		return (EBADF);
 
 	/*
+	 * The following commands are no longer supported. They were present on
+	 * SPARC and were always errors on other platforms. We now explicitly
+	 * return ENOTSUP to indicate that this is no longer done.
+	 */
+	switch (cmd) {
+	case PIOCSXREG:
+		return (ENOTSUP);
+	default:
+		break;
+	}
+
+	/*
 	 * Perform any necessary copyin() operations before
 	 * locking the process.  Helps avoid deadlocks and
 	 * improves performance.
 	 *
 	 * Also, detect invalid ioctl codes here to avoid
-	 * locking a process unnnecessarily.
+	 * locking a process unnecessarily.
 	 *
 	 * Also, prepare to allocate space that will be needed below,
 	 * case by case.
@@ -245,13 +258,8 @@
 	case PIOCMAXSIG:
 	case PIOCGXREGSIZE:
 		break;
-	case PIOCSXREG:		/* set extra registers */
 	case PIOCGXREG:		/* get extra registers */
-#if defined(__sparc)
-		thingsize = sizeof (prxregset_t);
-#else
-		thingsize = 0;
-#endif
+		thingsize = prgetprxregsize(p);
 		break;
 	case PIOCACTION:
 		thingsize = (nsig-1) * sizeof (struct sigaction);
@@ -392,17 +400,6 @@
 	case PIOCLUSAGE:
 		zdisp = ZYES;
 		break;
-	case PIOCSXREG:		/* set extra registers */
-		/*
-		 * perform copyin before grabbing the process lock
-		 */
-		if (thing) {
-			if (copyin(cmaddr, thing, thingsize)) {
-				kmem_free(thing, thingsize);
-				return (EFAULT);
-			}
-		}
-		/* fall through... */
 	default:
 		zdisp = ZNO;
 		break;
@@ -789,12 +786,19 @@
 
 	case PIOCGXREGSIZE:	/* get the size of the extra registers */
 	{
-		int xregsize;
-
 		if (prhasx(p)) {
+			size_t xregsize;
+			int abisize;
+
 			xregsize = prgetprxregsize(p);
 			prunlock(pnp);
-			if (copyout(&xregsize, cmaddr, sizeof (xregsize)))
+			if (xregsize > INT_MAX) {
+				error = EOVERFLOW;
+				break;
+			}
+
+			abisize = (int)xregsize;
+			if (copyout(&abisize, cmaddr, sizeof (abisize)))
 				error = EFAULT;
 		} else {
 			prunlock(pnp);
@@ -825,24 +829,6 @@
 		}
 		break;
 
-	case PIOCSXREG:		/* set extra registers */
-		if (!ISTOPPED(t) && !VSTOPPED(t) && !DSTOPPED(t))
-			error = EBUSY;
-		else if (!prhasx(p))
-			error = EINVAL;	/* No extra register support */
-		else if (thing) {
-			/* drop p_lock while touching the lwp's stack */
-			mutex_exit(&p->p_lock);
-			prsetprxregs(lwp, thing);
-			mutex_enter(&p->p_lock);
-		}
-		prunlock(pnp);
-		if (thing) {
-			kmem_free(thing, thingsize);
-			thing = NULL;
-		}
-		break;
-
 	case PIOCSTATUS:	/* get process/lwp status */
 		oprgetstatus(t, &un.prstat, VTOZONE(vp));
 		prunlock(pnp);
@@ -1764,12 +1750,24 @@
 		return (EBADF);
 
 	/*
+	 * The following commands are no longer supported. They were present on
+	 * SPARC and were always errors on other platforms. We now explicitly
+	 * return ENOTSUP to indicate that this is no longer done.
+	 */
+	switch (cmd) {
+	case PIOCSXREG:
+		return (ENOTSUP);
+	default:
+		break;
+	}
+
+	/*
 	 * Perform any necessary copyin() operations before
 	 * locking the process.  Helps avoid deadlocks and
 	 * improves performance.
 	 *
 	 * Also, detect invalid ioctl codes here to avoid
-	 * locking a process unnnecessarily.
+	 * locking a process unnecessarily.
 	 *
 	 * Also, prepare to allocate space that will be needed below,
 	 * case by case.
@@ -1800,13 +1798,8 @@
 	case PIOCMAXSIG:
 	case PIOCGXREGSIZE:
 		break;
-	case PIOCSXREG:		/* set extra registers */
 	case PIOCGXREG:		/* get extra registers */
-#if defined(__sparc)
-		thingsize = sizeof (prxregset_t);
-#else
-		thingsize = 0;
-#endif
+		thingsize = prgetprxregsize(p);
 		break;
 	case PIOCACTION:
 		thingsize = (nsig-1) * sizeof (struct sigaction32);
@@ -1947,17 +1940,6 @@
 	case PIOCLUSAGE:
 		zdisp = ZYES;
 		break;
-	case PIOCSXREG:		/* set extra registers */
-		/*
-		 * perform copyin before grabbing the process lock
-		 */
-		if (thing) {
-			if (copyin(cmaddr, thing, thingsize)) {
-				kmem_free(thing, thingsize);
-				return (EFAULT);
-			}
-		}
-		/* fall through... */
 	default:
 		zdisp = ZNO;
 		break;
@@ -2384,12 +2366,19 @@
 
 	case PIOCGXREGSIZE:	/* get the size of the extra registers */
 	{
-		int xregsize;
-
 		if (prhasx(p)) {
+			size_t xregsize;
+			int abisize;
+
 			xregsize = prgetprxregsize(p);
 			prunlock(pnp);
-			if (copyout(&xregsize, cmaddr, sizeof (xregsize)))
+			if (xregsize > INT_MAX) {
+				error = EOVERFLOW;
+				break;
+			}
+
+			abisize = (int)xregsize;
+			if (copyout(&abisize, cmaddr, sizeof (abisize)))
 				error = EFAULT;
 		} else {
 			prunlock(pnp);
@@ -2418,26 +2407,6 @@
 			error = EFAULT;
 		if (thing) {
 			kmem_free(thing, thingsize);
-			thing = NULL;
-		}
-		break;
-
-	case PIOCSXREG:		/* set extra registers */
-		if (PROCESS_NOT_32BIT(p))
-			error = EOVERFLOW;
-		else if (!ISTOPPED(t) && !VSTOPPED(t) && !DSTOPPED(t))
-			error = EBUSY;
-		else if (!prhasx(p))
-			error = EINVAL;	/* No extra register support */
-		else if (thing) {
-			/* drop p_lock while touching the lwp's stack */
-			mutex_exit(&p->p_lock);
-			prsetprxregs(lwp, thing);
-			mutex_enter(&p->p_lock);
-		}
-		prunlock(pnp);
-		if (thing) {
-			kmem_free(thing, thingsize);
 			thing = NULL;
 		}
 		break;
--- old/usr/src/uts/common/fs/proc/prvnops.c	Wed Apr 12 20:33:31 2023
+++ new/usr/src/uts/common/fs/proc/prvnops.c	Wed Apr 12 20:33:31 2023
@@ -25,7 +25,7 @@
  * Copyright (c) 2017 by Delphix. All rights reserved.
  * Copyright 2020 OmniOS Community Edition (OmniOSce) Association.
  * Copyright 2022 MNX Cloud, Inc.
- * Copyright 2022 Oxide Computer Company
+ * Copyright 2023 Oxide Computer Company
  */
 
 /*	Copyright (c) 1984,	 1986, 1987, 1988, 1989 AT&T	*/
@@ -1737,24 +1737,44 @@
 static int
 pr_read_xregs(prnode_t *pnp, uio_t *uiop, cred_t *cr)
 {
-#if defined(__sparc)
 	proc_t *p;
 	kthread_t *t;
 	int error;
-	char *xreg;
+	void *xreg;
 	size_t size;
 
 	ASSERT(pnp->pr_type == PR_XREGS);
 
-	xreg = kmem_zalloc(sizeof (prxregset_t), KM_SLEEP);
-
 	if ((error = prlock(pnp, ZNO)) != 0)
-		goto out;
+		return (error);
 
 	p = pnp->pr_common->prc_proc;
 	t = pnp->pr_common->prc_thread;
 
-	size = prhasx(p)? prgetprxregsize(p) : 0;
+	/*
+	 * While we would prefer to do the allocation with holding the process
+	 * this way, we can only determine this size while holding the process
+	 * as the hold guarantees us:
+	 *
+	 *  o That the process in question actualy exists.
+	 *  o That the process in question cannot change the set of FPU features
+	 *    it has enabled.
+	 *
+	 * We will drop p_lock across the allocation call itself. This should be
+	 * safe as the enabled feature set should not change while the process
+	 * is locked (e.g. enabling extending FPU state like AMX on x86 should
+	 * require the process to be locked).
+	 */
+	size = prhasx(p) ? prgetprxregsize(p) : 0;
+	if (size == 0) {
+		prunlock(pnp);
+		return (0);
+	}
+	mutex_exit(&p->p_lock);
+	xreg = kmem_zalloc(size, KM_SLEEP);
+	mutex_enter(&p->p_lock);
+	ASSERT3U(size, ==, prgetprxregsize(p));
+
 	if (uiop->uio_offset >= size) {
 		prunlock(pnp);
 		goto out;
@@ -1768,11 +1788,8 @@
 
 	error = pr_uioread(xreg, size, uiop);
 out:
-	kmem_free(xreg, sizeof (prxregset_t));
+	kmem_free(xreg, size);
 	return (error);
-#else
-	return (0);
-#endif
 }
 
 static int
--- old/usr/src/uts/common/os/kmem.c	Wed Apr 12 20:33:31 2023
+++ new/usr/src/uts/common/os/kmem.c	Wed Apr 12 20:33:31 2023
@@ -20,11 +20,10 @@
  */
 /*
  * Copyright (c) 1994, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright (c) 2017, Joyent, Inc.
  * Copyright (c) 2012, 2017 by Delphix. All rights reserved.
  * Copyright 2015 Nexenta Systems, Inc.  All rights reserved.
  * Copyright 2018, Joyent, Inc.
- * Copyright 2020 Oxide Computer Company
+ * Copyright 2023 Oxide Computer Company
  */
 
 /*
@@ -2820,6 +2819,32 @@
 	mutex_enter(&cp->cache_lock);
 }
 
+/*
+ * kmem_rezalloc() is currently considered private until we sort out how we want
+ * to handle realloc vs. reallocf style interfaces.
+ */
+void *
+kmem_rezalloc(void *oldbuf, size_t oldsize, size_t newsize, int kmflag)
+{
+	void *newbuf = kmem_alloc(newsize, kmflag);
+	if (newbuf == NULL) {
+		return (NULL);
+	}
+
+	bcopy(oldbuf, newbuf, MIN(oldsize, newsize));
+	if (newsize > oldsize) {
+		void *start = (void *)((uintptr_t)newbuf + oldsize);
+		bzero(start, newsize - oldsize);
+	}
+
+	if (oldbuf != NULL) {
+		ASSERT3U(oldsize, !=, 0);
+		kmem_free(oldbuf, oldsize);
+	}
+
+	return (newbuf);
+}
+
 void *
 kmem_zalloc(size_t size, int kmflag)
 {
--- old/usr/src/uts/common/os/priv.c	Wed Apr 12 20:33:31 2023
+++ new/usr/src/uts/common/os/priv.c	Wed Apr 12 20:33:31 2023
@@ -112,7 +112,7 @@
  * Guts of prgetprivsize.
  */
 int
-priv_prgetprivsize(prpriv_t *tmpl)
+priv_prgetprivsize(const prpriv_t *tmpl)
 {
 	return (sizeof (prpriv_t) +
 	    PRIV_SETBYTES - sizeof (priv_chunk_t) +
--- old/usr/src/uts/common/sys/Makefile	Wed Apr 12 20:33:31 2023
+++ new/usr/src/uts/common/sys/Makefile	Wed Apr 12 20:33:31 2023
@@ -29,7 +29,7 @@
 # Copyright 2016 Hans Rosenfeld <rosenfeld@grumpf.hope-2000.org>
 # Copyright 2019 Peter Tribble.
 # Copyright 2015, Joyent, Inc. All rights reserved.
-# Copyright 2022 Oxide Computer Company
+# Copyright 2023 Oxide Computer Company
 #
 
 include $(SRC)/uts/Makefile.uts
@@ -551,6 +551,7 @@
 	stat.h			\
 	statfs.h		\
 	statvfs.h		\
+	stdalign.h		\
 	stdbool.h		\
 	stddef.h		\
 	stdint.h		\
--- old/usr/src/uts/common/sys/kmem.h	Wed Apr 12 20:33:31 2023
+++ new/usr/src/uts/common/sys/kmem.h	Wed Apr 12 20:33:31 2023
@@ -63,6 +63,7 @@
 extern void kmem_dump_init(size_t);
 extern void kmem_dump_begin(void);
 extern size_t kmem_dump_finish(char *buf, size_t size);
+extern void *kmem_rezalloc(void *, size_t, size_t, int);
 
 #endif	/* _KERNEL */
 
--- old/usr/src/uts/common/sys/priv.h	Wed Apr 12 20:33:32 2023
+++ new/usr/src/uts/common/sys/priv.h	Wed Apr 12 20:33:32 2023
@@ -205,7 +205,7 @@
 struct prpriv;
 struct cred;
 
-extern int priv_prgetprivsize(struct prpriv *);
+extern int priv_prgetprivsize(const struct prpriv *);
 extern void cred2prpriv(const struct cred *, struct prpriv *);
 extern int priv_pr_spriv(struct proc *, struct prpriv *, const struct cred *);
 
--- old/usr/src/uts/common/sys/prsystm.h	Wed Apr 12 20:33:32 2023
+++ new/usr/src/uts/common/sys/prsystm.h	Wed Apr 12 20:33:32 2023
@@ -56,6 +56,7 @@
 struct prpriv;
 struct prsecflags;
 struct prfdinfo;
+struct prxregset;
 
 struct seg;
 struct regs;
@@ -77,8 +78,8 @@
 extern void prgetpsinfo(proc_t *, struct psinfo *);
 extern void prgetlwpsinfo(kthread_t *, struct lwpsinfo *);
 extern void prgetprfpregs(klwp_t *, struct prfpregset *);
-extern void prgetprxregs(klwp_t *, caddr_t);
-extern int  prgetprxregsize(proc_t *);
+extern void prgetprxregs(klwp_t *, struct prxregset *);
+extern size_t prgetprxregsize(proc_t *);
 extern void prgetcred(proc_t *, struct prcred *);
 extern void prgetpriv(proc_t *, struct prpriv *);
 extern size_t prgetprivsize(void);
--- /dev/null	Wed Apr 12 20:33:32 2023
+++ new/usr/src/uts/common/sys/stdalign.h	Wed Apr 12 20:33:32 2023
@@ -0,0 +1,56 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2016 Joyent, Inc.
+ * Copyright 2023 Oxide Computer Company
+ */
+
+#ifndef _SYS_STDALIGN_H
+#define	_SYS_STDALIGN_H
+
+/*
+ * ISO/IEC C11 stdalign.h. This header is meant to provide definitions for the
+ * alignas and alignof 'keywords' into the underlying compiler-understood value.
+ * In addition, there are two macros that are meant to define that this process
+ * has happened. C++11 added alignas/alignof as keywords and including this
+ * header is meant to cause us to still have the _is_defined macros, but not
+ * define this overall.
+ *
+ * Unlike other cases we don't use any symbol guards here (other than C++) and
+ * just allow the implementation to either have _Alignas and _Alignof or not
+ * have it and lead to a compiler error for the user. The main justification of
+ * this is that this header is only defined in C11 (and newer). It's not defined
+ * in other standards and just as if you include a non-standard header, in this
+ * case we don't try to stop that (same as if you included something like
+ * libdevinfo.h).
+ */
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#ifndef	__cplusplus
+
+#define	alignas	_Alignas
+/*CSTYLED*/
+#define	alignof	_Alignof
+
+#endif	/* !__cplusplus */
+
+#define	__alignas_is_defined	1
+#define	__alignof_is_defined	1
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* _SYS_STDALIGN_H */
--- old/usr/src/uts/common/sys/types.h	Wed Apr 12 20:33:32 2023
+++ new/usr/src/uts/common/sys/types.h	Wed Apr 12 20:33:32 2023
@@ -28,7 +28,7 @@
  *
  * Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
  * Copyright 2016 Joyent, Inc.
- * Copyright 2021 Oxide Computer Company
+ * Copyright 2023 Oxide Computer Company
  */
 
 #ifndef _SYS_TYPES_H
@@ -261,6 +261,16 @@
 	uint32_t	_l[4];
 } upad128_t;
 
+typedef union {
+	long double	_q[2];
+	uint32_t	_l[8];
+} upad256_t;
+
+typedef union {
+	long double	_q[4];
+	uint32_t	_l[16];
+} upad512_t;
+
 typedef	longlong_t	offset_t;
 typedef	u_longlong_t	u_offset_t;
 typedef u_longlong_t	len_t;
--- old/usr/src/uts/intel/brand/lx/lx_archdep.c	Wed Apr 12 20:33:32 2023
+++ new/usr/src/uts/intel/brand/lx/lx_archdep.c	Wed Apr 12 20:33:32 2023
@@ -1449,7 +1449,8 @@
 		 * restoring it when the emulation is complete would clobber
 		 * those intentional side effects.
 		 */
-		savecontext(&uc, NULL);
+		/* XXX KEBE ASKS PLUMB UP EXTENDED?!? */
+		savecontext(&uc, NULL, 0);
 
 		if (on_fault(&lab)) {
 			goto badstack;
@@ -1617,7 +1618,8 @@
 		 * restoring it when the emulation is complete would clobber
 		 * those intentional side effects.
 		 */
-		savecontext32(&uc, NULL);
+		/* XXX KEBE ASKS PLUMB UP EXTENDED?!? */
+		savecontext32(&uc, NULL, 0);
 
 		if (on_fault(&lab)) {
 			goto badstack;
--- old/usr/src/uts/intel/fs/proc/prmachdep.c	Wed Apr 12 20:33:32 2023
+++ new/usr/src/uts/intel/fs/proc/prmachdep.c	Wed Apr 12 20:33:32 2023
@@ -25,8 +25,12 @@
  */
 
 /*	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T	*/
-/*	  All Rights Reserved  	*/
+/*	  All Rights Reserved	*/
 
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
 #include <sys/types.h>
 #include <sys/t_lock.h>
 #include <sys/param.h>
@@ -47,6 +51,7 @@
 #include <sys/signal.h>
 #include <sys/user.h>
 #include <sys/cpuvar.h>
+#include <sys/stdalign.h>
 
 #include <sys/fault.h>
 #include <sys/syscall.h>
@@ -236,43 +241,200 @@
 #endif	/* _SYSCALL32_IMPL */
 
 /*
- * Does the system support extra register state?
+ * This is a general function that the main part of /proc and the rest of the
+ * system uses to ask does a given process actually have extended state. Right
+ * now, this question is not process-specific, but rather CPU specific. We look
+ * at whether xsave has been enabled to determine that. While strictly speaking
+ * one could make the argument that all amd64 CPUs support fxsave and we could
+ * emulate something that only supports that, we don't think that makes sense.
  */
-/* ARGSUSED */
 int
 prhasx(proc_t *p)
 {
-	return (0);
+	return (fpu_xsave_enabled());
 }
 
 /*
- * Get the size of the extra registers.
+ * Return the minimum size that we need to determine the full size of a
+ * prxregset_t.
  */
-/* ARGSUSED */
-int
+boolean_t
+prwriteminxreg(size_t *sizep)
+{
+	*sizep = sizeof (prxregset_hdr_t);
+	return (B_TRUE);
+}
+
+/*
+ * This routine services both ILP32 and LP64 callers. We cannot assume anything
+ * about the alignment of argp and must bcopy things to known structures that we
+ * care about. We are guaranteed we have prxregset_hdr_t bytes because we asked
+ * for them above.
+ */
+boolean_t
+prwritesizexreg(const void *argp, size_t *sizep)
+{
+	prxregset_hdr_t hdr;
+
+	/*
+	 * While it's tempting to validate everything here, the only thing we
+	 * care about is that we understand the type and the size meets our
+	 * constraints:
+	 *
+	 *  o We actually have an item of type PR_TYPE_XSAVE, otherwise we
+	 *    don't know what this is.
+	 *  o The indicated size actually contains at least the
+	 *    prxregset_hdr_t.
+	 *  o The indicated size isn't larger than what the FPU tells us is
+	 *    allowed.
+	 *
+	 * We do not check if the reset of the structure makes semantic sense at
+	 * this point. We save all other validation for the normal set function
+	 * as that's when we'll have the rest of our data.
+	 */
+	bcopy(argp, &hdr, sizeof (hdr));
+	if (hdr.pr_type != PR_TYPE_XSAVE ||
+	    hdr.pr_size > fpu_proc_xregs_max_size() ||
+	    hdr.pr_size < sizeof (prxregset_hdr_t)) {
+		return (B_FALSE);
+	}
+
+	*sizep = hdr.pr_size - sizeof (prxregset_hdr_t);
+	return (B_TRUE);
+}
+
+/*
+ * Get the size of the extra registers. The ultimate size here depends on a
+ * combination of a few different things. Right now the xregs always have our
+ * header, the illumos-specific XCR information, the xsave information, and then
+ * otherwise this varies based on the items that the CPU supports.
+ *
+ * The ultimate size here is going to be:
+ *
+ *  o 1x prxregset_hdr_t
+ *  o n  prxregset_info_t structures
+ *  o The individual data for each one
+ */
+size_t
 prgetprxregsize(proc_t *p)
 {
-	return (0);
+	uint32_t size;
+
+	fpu_proc_xregs_info(p, NULL, &size, NULL);
+	return (size);
 }
 
 /*
  * Get extra registers.
  */
-/*ARGSUSED*/
 void
-prgetprxregs(klwp_t *lwp, caddr_t prx)
+prgetprxregs(klwp_t *lwp, prxregset_t *prx)
 {
-	/* no extra registers */
+	fpu_proc_xregs_get(lwp, prx);
 }
 
 /*
  * Set extra registers.
+ *
+ * We've been given a regset to set. Before we hand it off to the FPU, we have
+ * to go through and make sure that the different parts of this actually make
+ * sense. The kernel has guaranteed us through the functions above that we have
+ * the number of bytes that the header indicates are present. In particular we
+ * need to validate:
+ *
+ *   o The information in the header is reasonable: we have a known type, flags
+ *     and padding are zero, and there is at least one info structure.
+ *   o Each of the info structures has a valid type, size, and fits within the
+ *     data we were given.
+ *   o We do not validate or modify the actual data in the different pieces for
+ *     validity. That is considered something that the FPU does. Similarly if
+ *     something is read-only or not used, that is something that it checks.
+ *
+ * While we would like to return something other than EINVAL, the /proc APIs
+ * pretty much lead that to being the primary errno for all sorts of situations.
  */
-/*ARGSUSED*/
-void
-prsetprxregs(klwp_t *lwp, caddr_t prx)
+int
+prsetprxregs(klwp_t *lwp, prxregset_t *prx)
 {
-	/* no extra registers */
+	size_t infosz;
+	prxregset_hdr_t *hdr = (prxregset_hdr_t *)prx;
+
+	if (hdr->pr_type != PR_TYPE_XSAVE || hdr->pr_flags != 0 ||
+	    hdr->pr_pad[0] != 0 || hdr->pr_pad[1] != 0 || hdr->pr_pad[2] != 0 ||
+	    hdr->pr_pad[3] != 0 || hdr->pr_ninfo == 0) {
+		return (EINVAL);
+	}
+
+	infosz = hdr->pr_ninfo * sizeof (prxregset_info_t) +
+	    sizeof (prxregset_hdr_t);
+	if (infosz > hdr->pr_size) {
+		return (EINVAL);
+	}
+
+	for (uint32_t i = 0; i < hdr->pr_ninfo; i++) {
+		uint32_t exp_size;
+		size_t need_len, exp_align;
+		const prxregset_info_t *info = &hdr->pr_info[i];
+
+		switch (info->pri_type) {
+		case PRX_INFO_XCR:
+			exp_size = sizeof (prxregset_xcr_t);
+			exp_align = alignof (prxregset_xcr_t);
+			break;
+		case PRX_INFO_XSAVE:
+			exp_size = sizeof (prxregset_xsave_t);
+			exp_align = alignof (prxregset_xsave_t);
+			break;
+		case PRX_INFO_YMM:
+			exp_size = sizeof (prxregset_ymm_t);
+			exp_align = alignof (prxregset_ymm_t);
+			break;
+		case PRX_INFO_OPMASK:
+			exp_size = sizeof (prxregset_opmask_t);
+			exp_align = alignof (prxregset_opmask_t);
+			break;
+		case PRX_INFO_ZMM:
+			exp_size = sizeof (prxregset_zmm_t);
+			exp_align = alignof (prxregset_zmm_t);
+			break;
+		case PRX_INFO_HI_ZMM:
+			exp_size = sizeof (prxregset_hi_zmm_t);
+			exp_align = alignof (prxregset_hi_zmm_t);
+			break;
+		default:
+			return (EINVAL);
+		}
+
+		if (info->pri_flags != 0 || info->pri_size != exp_size) {
+			return (EINVAL);
+		}
+
+		if ((info->pri_offset % exp_align) != 0) {
+			return (EINVAL);
+		}
+
+		/*
+		 * No bytes of this item's entry should overlap with the
+		 * information area. If users want to overlap the actual data
+		 * information for some odd reason, we don't check that and let
+		 * them do what they want. However, the total data for this
+		 * region must actually fit. Because exp_size and pri_offset are
+		 * uint32_t's, we can sum them without overflow worries in an
+		 * LP64 environment.
+		 *
+		 * While we try to grantee alignment when writing this structure
+		 * out to userland, that is in no way a requirement and users
+		 * are allowed to start these structures wherever they want.
+		 * Hence that is not checked here.
+		 */
+		need_len = (size_t)exp_size + (size_t)info->pri_offset;
+		if (info->pri_offset < infosz ||
+		    need_len > (size_t)hdr->pr_size) {
+			return (EINVAL);
+		}
+	}
+
+	return (fpu_proc_xregs_set(lwp, prx));
 }
 
 /*
--- old/usr/src/uts/intel/os/archdep.c	Wed Apr 12 20:33:32 2023
+++ new/usr/src/uts/intel/os/archdep.c	Wed Apr 12 20:33:32 2023
@@ -27,7 +27,7 @@
 /*
  * Copyright (c) 2018, Joyent, Inc.
  * Copyright 2012 Nexenta Systems, Inc.  All rights reserved.
- * Copyright 2022 Oxide Computer Company
+ * Copyright 2023 Oxide Computer Company
  */
 
 #include <sys/param.h>
@@ -239,48 +239,7 @@
 void
 setfpregs(klwp_t *lwp, fpregset_t *fp)
 {
-	struct fpu_ctx *fpu = &lwp->lwp_pcb.pcb_fpu;
-
-	if (fpu->fpu_flags & FPU_EN) {
-		if (!(fpu->fpu_flags & FPU_VALID)) {
-			/*
-			 * FPU context is still active, release the
-			 * ownership.
-			 */
-			fp_free(fpu);
-		}
-	}
-	/*
-	 * Else: if we are trying to change the FPU state of a thread which
-	 * hasn't yet initialized floating point, store the state in
-	 * the pcb and indicate that the state is valid.  When the
-	 * thread enables floating point, it will use this state instead
-	 * of the default state.
-	 */
-
-	switch (fp_save_mech) {
-	case FP_FXSAVE:
-		fpregset_to_fxsave(fp, fpu->fpu_regs.kfpu_u.kfpu_fx);
-		fpu->fpu_regs.kfpu_xstatus =
-		    fp->fp_reg_set.fpchip_state.xstatus;
-		break;
-
-	case FP_XSAVE:
-		fpregset_to_fxsave(fp,
-		    &fpu->fpu_regs.kfpu_u.kfpu_xs->xs_fxsave);
-		fpu->fpu_regs.kfpu_xstatus =
-		    fp->fp_reg_set.fpchip_state.xstatus;
-		fpu->fpu_regs.kfpu_u.kfpu_xs->xs_header.xsh_xstate_bv |=
-		    (XFEATURE_LEGACY_FP | XFEATURE_SSE);
-		break;
-	default:
-		panic("Invalid fp_save_mech");
-		/*NOTREACHED*/
-	}
-
-	fpu->fpu_regs.kfpu_status = fp->fp_reg_set.fpchip_state.status;
-	fpu->fpu_flags |= FPU_VALID;
-	PCB_SET_UPDATE_FPU(&lwp->lwp_pcb);
+	fpu_set_fpregset(lwp, fp);
 }
 
 /*
@@ -289,74 +248,8 @@
 void
 getfpregs(klwp_t *lwp, fpregset_t *fp)
 {
-	struct fpu_ctx *fpu = &lwp->lwp_pcb.pcb_fpu;
-
-	kpreempt_disable();
-	if (fpu->fpu_flags & FPU_EN) {
-		/*
-		 * If we have FPU hw and the thread's pcb doesn't have
-		 * a valid FPU state then get the state from the hw.
-		 */
-		if (fpu_exists && ttolwp(curthread) == lwp &&
-		    !(fpu->fpu_flags & FPU_VALID))
-			fp_save(fpu); /* get the current FPU state */
-	}
-
-	/*
-	 * There are 3 possible cases we have to be aware of here:
-	 *
-	 * 1. FPU is enabled.  FPU state is stored in the current LWP.
-	 *
-	 * 2. FPU is not enabled, and there have been no intervening /proc
-	 *    modifications.  Return initial FPU state.
-	 *
-	 * 3. FPU is not enabled, but a /proc consumer has modified FPU state.
-	 *    FPU state is stored in the current LWP.
-	 */
-	if ((fpu->fpu_flags & FPU_EN) || (fpu->fpu_flags & FPU_VALID)) {
-		/*
-		 * Cases 1 and 3.
-		 */
-		switch (fp_save_mech) {
-		case FP_FXSAVE:
-			fxsave_to_fpregset(fpu->fpu_regs.kfpu_u.kfpu_fx, fp);
-			fp->fp_reg_set.fpchip_state.xstatus =
-			    fpu->fpu_regs.kfpu_xstatus;
-			break;
-		case FP_XSAVE:
-			fxsave_to_fpregset(
-			    &fpu->fpu_regs.kfpu_u.kfpu_xs->xs_fxsave, fp);
-			fp->fp_reg_set.fpchip_state.xstatus =
-			    fpu->fpu_regs.kfpu_xstatus;
-			break;
-		default:
-			panic("Invalid fp_save_mech");
-			/*NOTREACHED*/
-		}
-		fp->fp_reg_set.fpchip_state.status = fpu->fpu_regs.kfpu_status;
-	} else {
-		/*
-		 * Case 2.
-		 */
-		switch (fp_save_mech) {
-		case FP_FXSAVE:
-		case FP_XSAVE:
-			/*
-			 * For now, we don't have any AVX specific field in ABI.
-			 * If we add any in the future, we need to initial them
-			 * as well.
-			 */
-			fxsave_to_fpregset(&sse_initial, fp);
-			fp->fp_reg_set.fpchip_state.xstatus =
-			    fpu->fpu_regs.kfpu_xstatus;
-			break;
-		default:
-			panic("Invalid fp_save_mech");
-			/*NOTREACHED*/
-		}
-		fp->fp_reg_set.fpchip_state.status = fpu->fpu_regs.kfpu_status;
-	}
-	kpreempt_enable();
+	bzero(fp, sizeof (*fp));
+	fpu_get_fpregset(lwp, fp);
 }
 
 #if defined(_SYSCALL32_IMPL)
@@ -528,6 +421,12 @@
 	dst->uc_brand_data[0] = (void *)(uintptr_t)src->uc_brand_data[0];
 	dst->uc_brand_data[1] = (void *)(uintptr_t)src->uc_brand_data[1];
 	dst->uc_brand_data[2] = (void *)(uintptr_t)src->uc_brand_data[2];
+
+	if (src->uc_flags & UC_XSAVE) {
+		dst->uc_xsave = (long)(uint32_t)src->uc_xsave;
+	} else {
+		dst->uc_xsave = 0;
+	}
 }
 
 #endif	/* _SYSCALL32_IMPL */
@@ -537,7 +436,7 @@
  * If in a system call, return the address of the syscall trap.
  */
 greg_t
-getuserpc()
+getuserpc(void)
 {
 	greg_t upc = lwptoregs(ttolwp(curthread))->r_pc;
 	uint32_t insn;
